﻿Type=Activity
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Type typItemData(Text As String, Anim As ClsAnimatedTranslation)
End Sub

Sub Globals
	Dim ULV, ULV_Bkmk As UltimateListView
	Dim mapItems As Map
	Dim SelectedItem As Int = -1
	Dim BlinkAnim As AnimationPlus
	Dim Index_Label As Int = 0
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.Color = 0xfff3f3f3

	'Initializes an ULV and builds its list
	ULV.Initialize(0, 0, "", "ULV")
	ULV.SetPadding(5dip, 5dip, 5dip, 5dip)
	ULV.SetStyle(ULV.STYLE_HOLO_LIGHT)
	ULV.FadingEdges(False)
	ULV.AddLayout("Item", "Item_LayoutCreator", "Item_ContentFiller", 60dip, True)
	mapItems.Initialize
	For i = 0 To 300
		Dim NewItem As typItemData
		NewItem.Initialize
		NewItem.Text = "Item #" & (i + 1)
		NewItem.Anim.Initialize(Me, "Anim_AnimationEnd")
		Dim ID As Long = i
		mapItems.Put(ID, NewItem)
		ULV.AddItem("Item", ID)
		ULV.SetSwipeDirection(i, ULV.SWIPE_DIRECTION_RIGHT)
	Next
	ULV.AnimationCleaner = True
	Activity.AddView(ULV, 0, 0, 100%x - 80dip, 100%y)

	'Initializes another ULV for the bookmarks
	ULV_Bkmk.Initialize(0, 0, "", "ULVbookmarks")
	ULV_Bkmk.SetPadding(5dip, 5dip, 5dip, 5dip)
	ULV_Bkmk.SetStyle(ULV.STYLE_HOLO_DARK)
	ULV_Bkmk.AddLayout("Bookmark", "Bookmark_LayoutCreator", "Bookmark_ContentFiller", 60dip, True)
	Activity.AddView(ULV_Bkmk, 100%x - 80dip, 0, 80dip, 100%y)
End Sub

Sub Activity_Resume
	ULV_Bkmk.Enabled = True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub Item_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Just a label
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.Black
	lbl.TextSize = 20
	lbl.Typeface = Typeface.DEFAULT
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	LayoutPanel.AddView(lbl, 10dip, 5dip, LayoutPanel.Width - 20dip, LayoutPanel.Height - 9dip)
End Sub

Sub Bookmark_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	'Just a label
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextColor = Colors.White
	lbl.TextSize = 20
	lbl.Typeface = Typeface.DEFAULT
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	LayoutPanel.AddView(lbl, 10dip, 5dip, LayoutPanel.Width - 20dip, LayoutPanel.Height - 9dip)
End Sub

Sub Item_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	'Updates the text
	Dim lbl As Label = LayoutPanel.GetView(Index_Label)
	Dim ItemData As typItemData = mapItems.Get(ItemID)
	lbl.Text = ItemData.Text

	'Stores the ItemID in the label Tag
	lbl.Tag = ItemID

	'Updates the color of the layout panel
	If Position = SelectedItem Then
		'The selected item quickly blinks to show its position
		LayoutPanel.Color = Colors.RGB(255, 100, 100)
		BlinkAnim.InitializeAlpha("BlinkAnim", 0, 1)
		BlinkAnim.Duration = 80
		BlinkAnim.RepeatCount = 2
		BlinkAnim.SetInterpolator(BlinkAnim.INTERPOLATOR_LINEAR)
		BlinkAnim.Start(LayoutPanel)
		ULV_Bkmk.Enabled = False
	Else
		LayoutPanel.Color = Colors.LightGray
	End If
End Sub

Sub Bookmark_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	'Updates the text
	Dim lbl As Label = LayoutPanel.GetView(0)
	lbl.Text = "#" & (ItemID + 1)
End Sub

Sub ULV_SwipeBegin(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int) As Boolean
	'Ignores any new gesture until the animation has ended
	Dim Item As typItemData = mapItems.Get(ULV.GetItemID(Position))
	Return Not(Item.Anim.IsStarted)
End Sub

Sub ULV_Swiped(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int, DeltaX As Int)
	'Moves the label
	Dim lbl As Label = LayoutPanel.GetView(Index_Label)
	lbl.Left = Min(Max(10dip, DeltaX), LayoutPanel.Width)
End Sub

Sub ULV_SwipeCancelled(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int)
	'Cancels any change of the label position
	Dim lbl As Label = LayoutPanel.GetView(Index_Label)
	lbl.Left = 10dip
End Sub

Sub ULV_SwipeEnd(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int, VelocityX As Float)
	Dim lbl As Label = LayoutPanel.GetView(Index_Label)
	If lbl.Left < ULV.Width * 0.3 Then
		'The label didn't move far enough -> it returns to its initial position
		Dim Item As typItemData = mapItems.Get(ULV.GetItemID(Position))
		Item.Anim.Start(lbl, -1, 10dip, Min((lbl.Left - 10dip) / 2, 300))
		ULV_Bkmk.Enabled = False
		Return
	End If
	If LayoutPanel.Width - lbl.Left <= 0 Then
		'Right edge already reached -> no need to animate
		Anim_AnimationEnd(lbl, lbl.Tag)
	Else
		'Animates the label to reach the right edge
		Dim Item As typItemData = mapItems.Get(ULV.GetItemID(Position))
		Item.Anim.Start(lbl, lbl.Tag, LayoutPanel.Width, Min(Abs((LayoutPanel.Width - lbl.Left) / VelocityX / 2), 300))
		ULV_Bkmk.Enabled = False
	End If
End Sub

Sub Anim_AnimationEnd(AnimatedLabel As View, ItemID As Long)
	'Returns the label to its initial position
	AnimatedLabel.Left = 10dip

	'Adds a bookmark
	If ItemID > -1 Then
		Dim Bookmark_Position As Int = ULV_Bkmk.NumberOfItems
		For i = 0 To ULV_Bkmk.NumberOfItems - 1
			If ULV_Bkmk.GetItemID(i) = ItemID Then
				'The bookmark already exists
				Return
			Else If ItemID < ULV_Bkmk.GetItemID(i) Then
				'Bookmarks are sorted in ascending order
				Bookmark_Position = i
				Exit
			End If
		Next
		ULV_Bkmk.InsertItemAt("Bookmark", ItemID, Bookmark_Position)
	End If

	'The bookmark list is disabled when the animation starts and reenabled when the animation ends
	ULV_Bkmk.Enabled = True
End Sub

Sub ULVbookmarks_ItemClick(ItemID As Long, Position As Int, ClickedPanel As Panel)
	'Selects the item corresponding to the bookmark
	ULV.EnsureVisibility(ULV.GetPositionForID(ItemID, False))
	DoEvents 'Allows some time to ULV to reach the position

	'Flashes its panel
	SelectedItem = ULV.GetPositionForID(ItemID, False)
	ULV.RefreshContent
End Sub

Sub BlinkAnim_AnimationEnd
	'Resets the selected item
	SelectedItem = -1
	ULV.RefreshContent
	BlinkAnim = Null

	'The bookmark list is disabled when the animation starts and reenabled when the animation ends
	ULV_Bkmk.Enabled = True
End Sub
