﻿Type=Activity
Version=5.02
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
End Sub

Sub Globals
	Dim ULV As UltimateListView
	Dim HSV As HorizontalSlaveView
	Dim Header As Panel
	Dim ScrollX, StartX As Int
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Creates a horizontal scrollview (slave version)
	Dim CellWidth As Int = 70%x
	HSV.Initialize(CellWidth * 4)
	Activity.AddView(HSV, 0, 0, 100%x, 100%y)

	'Disables the over-scroll of the HSV (if the OS allows it)
	Try
		Dim jHSV As JavaObject = HSV
		jHSV.RunMethod("setOverScrollMode", Array As Object(2)) '2 = OVER_SCROLL_NEVER
	Catch
		'Not allowed by the OS
		Log("Cannot disable the over-scroll")
	End Try

	'Creates a header with four colored panels
	Header.Initialize("")
	Dim Cells(4) As Panel
	Dim X As Int = 0
	For i = 0 To 3
		Cells(i).Initialize("")
		Select i
			Case 0: Cells(i).Color = Colors.Green
			Case 1: Cells(i).Color = Colors.Red
			Case 2: Cells(i).Color = Colors.Blue
			Case 3: Cells(i).Color = Colors.Yellow
		End Select
		Header.AddView(Cells(i), X, 0, CellWidth, -1)
		X = X + Cells(i).Width
	Next
	HSV.Panel.AddView(Header, 0, 0, CellWidth * 4, 50dip)

	'Initializes an ULV and builds its list
	ULV.Initialize(0, 0, "", "ULV")
	ULV.SetStyle(ULV.STYLE_HOLO_LIGHT)
	ULV.FastScroller(True)
	ULV.AddRowLayout("Item", "Item_RowLayoutCreator", "Item_RowContentFiller", 60dip, 4, Array As Int(CellWidth, CellWidth, CellWidth, CellWidth), 0, Colors.Transparent, True)
	ULV.BulkAddItems(300, "Item", 1)
	HSV.Panel.AddView(ULV, 0, Header.Height, CellWidth * 4, HSV.Height - Header.Height)

	'All swipes are detected at the list level and don't block the vertical scroll
	ULV.SwipeMode = ULV.SWIPE_MODE_LIST_DIR_ALL
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Sub Item_RowLayoutCreator(LayoutName As String, CellPanel As Panel, CellIndex As Byte)
	'Just a label over a colored panel
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Color = Colors.Transparent
	lbl.TextSize = 20
	lbl.TextColor = Colors.Black
	lbl.Typeface = Typeface.DEFAULT
	lbl.Gravity = Gravity.LEFT + Gravity.CENTER_VERTICAL
	CellPanel.AddView(lbl, 10dip, 5dip, CellPanel.Width - 20dip, CellPanel.Height - 9dip)

	If CellIndex = 0 Then
		CellPanel.Color = Colors.ARGB(60, 0, 255, 0)
	Else If CellIndex = 1 Then
		CellPanel.Color = Colors.ARGB(60, 255, 0, 0)
	Else If CellIndex = 2 Then
		CellPanel.Color = Colors.ARGB(60, 0, 0, 255)
	Else
		CellPanel.Color = Colors.ARGB(60, 255, 255, 0)
	End If
End Sub

Sub Item_RowContentFiller(RowID As Long, LayoutName As String, CellPanel As Panel, CellIndex As Byte, Position As Int)
	'Updates the text
	Dim lbl As Label = CellPanel.GetView(0)
	lbl.Text = "ID " & RowID & ", cell #" & CellIndex
End Sub

Sub ULV_SwipeBegin(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int) As Boolean
	'Memorizes the scroll position of the HSV and the finger position
	ScrollX = HSV.ScrollPosition
	StartX = ScreenX
	Return True
End Sub

Sub ULV_Swiped(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int, DeltaX As Int)
	'Scrolls the HSV
	HSV.ScrollPosition = ScrollX + StartX - ScreenX
End Sub

Sub ULV_SwipeCancelled(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int)
End Sub

Sub ULV_SwipeEnd(Position As Int, LayoutPanel As Panel, LocalX As Int, ScreenX As Int, VelocityX As Float)
	'Sends the fling velocity to the HSV
	Dim Velocity As Int = VelocityX * 1000
	If Abs(Velocity) > 75 Then
		HSV.Fling(Velocity)
	End If
End Sub

Sub ULV_CellClick(RowID As Long, CellIndex As Byte, Position As Int, ClickedPanel As Panel)
	ToastMessageShow("Click: ID " & RowID & ", cell #" & CellIndex, False)
End Sub
